/**** IDENTIFICATION ***************************************************/
/*                                                                     */
/*    Project: Funkmodul                    Autor : Florian Scherb     */
/*    Module : defines.h                    Source: defines.h          */
/*                                                                     */
/*                                                                     */
/* == FUNCTIONAL DESCRIPTION OF MODULE =============================== */
/*                                                                     */
/*    This module contains all global synonyms.                        */
/*                                                                     */
/*                                                                     */
/***********************************************************************/
#define Hausnummer1
//#define Hausnummer2
#define slogo8
//#define slogo64
//#define DEBUG

#ifdef slogo8
#define STARTTIMER2 |= (1<<CS01)
#elif defined slogo64
#define STARTTIMER2 |= (1<<CS02)
#else 
#define STARTTIMER2 |= (1<<CS00)
#endif


/*** DEFINITION OF GLOBAL SYNONYMS *************************************/

// *** SYSTEM INFORMATION ***
#define VERSION 			"Rev. 1.1.0  "		//Version of this programm
#ifndef F_CPU
#define F_CPU 				8000000				// CPU frequency
#endif	
#define F_PERIOD			125UL				// CPU period in ns
#define UART_BAUD_RATE      9600  				// UART frequency on startup
#define SLAVE_ADRESSE 0x50			 			// I2C Slave Adress
// ***************************


// * CONTROL PINS MDSEL AND RECC *
#define CTRL_IPN_MDSEL		PIND2				// Input Pin number of the control pin MDSEL
#define CTRL_PIN_MDSEL		PIND				// Pin declaration of the control pin MDSEL
#define CTRL_PORT_MDSEL		PORTD				// Port declaration of the control pin MDSEL
#define CTRL_DDR_MDSEL		DDRD				// Data direction register of the control pin MDSEL
#define CTRL_PNR_MDSEL		PD2					// Pin number of control pin MDSEL

#define CTRL_IPN_RECC		PIND3				// Input Pin number of the control pin RECC
#define CTRL_PIN_RECC		PIND				// Pin declaration of the control pin RECC
#define CTRL_PORT_RECC		PORTD				// Port declaration of the control pin RECC
#define CTRL_DDR_RECC		DDRD				// Data direction register of the control pin RECC
#define CTRL_PNR_RECC		PD3					// Pin number of control pin RECC
// ***************************


// ***** LED DEFINITIONS *****
#define LED_DDR_RECEIVING	DDRC				// Data direction reg. of Receiving LED
#define LED_DDR_TRANSMITT	DDRC				// Data direction reg. of Transmitting LED
#define LED_DDR_POWERGOOD	DDRB				// Data direction reg. of Power Good LED

#define LED_PORT_RECEIVING	PORTC				// Port declaration of Receiving LED
#define LED_PORT_TRANSMITT	PORTC				// Port declaration of Transmitting LED
#define LED_PORT_POWERGOOD	PORTB				// Port declaration of Power Good LED

#define LED_PNR_RECEIVING	PC3					// Pin number of Receiving LED
#define LED_PNR_TRANSMITT 	PC2					// Pin number of Transmitting LED
#define LED_PNR_POWERGOOD 	PB0					// Pin number of Power Good LED

#define LED_IPN_RECEIVING 	PINC3				// Input Pin number of Receiving LED
#define LED_IPN_TRANSMITT 	PINC2				// Input Pin number of Transmitting LED
#define LED_IPN_POWERGOOD 	PINB0				// Input Pin number of Power good LED

#define LED_PIN_RECEIVING 	PINC				// Pin declaration of Receiving LED
#define LED_PIN_TRANSMITT 	PINC				// Pin declaration of Transmitting LED
#define LED_PIN_POWERGOOD 	PINB				// Pin declaration of Power Good LED

#define LED_POWERGOOD 		1					// For leds.c: Power good LED
#define LED_RECEIVING 		2					// For leds.c: Radio signal received
#define LED_TRANSMITT		3					// For leds.c: Transmitting data
// ***************************


// *** MAX3221 DEFINITIONS ***
#define MAX_DDR_MAX3221		DDRA				// Data direction reg. of MAX3221 pins
#define MAX_PORT_MAX3221	PORTA				// Port declaration of MAX3221 pins

#define MAX_PNR_FORCEOFF	PA3					// Pin number of MAX3221 FORCEOFF pin
#define MAX_PNR_FORCEON		PA2					// Pin number of MAX3221 FORCEOON pin
#define MAX_PNR_INVALID		PA1					// Pin number of MAX3221 INVALID pin
#define MAX_PNR_ENABLE		PA0					// Pin number of MAX3221 ENABLE pin

#define MAX_IPN_INVALID 	PINA1				// Input Pin number of MAX3221 INVALID pin
#define MAX_PIN_INVALID 	PINA				// Pin declaration of MAX3221 INVALID pin
// ***************************


// ** ZLDO PIN ASSIGNMENTS ***	
#define ZLDO_DDR_LBF		DDRD				// Data direction reg. of ZLDO LBF pin
#define ZLDO_PORT_LBF		PORTD				// Port declaration of ZLDO LBF pin
#define ZLDO_PNR_LBF		PD5					// Pin number of ZLDO LBF pin
#define ZLDO_IPN_LBF		PIND5				// Input Pin number of ZLDO LBF pin
#define ZLDO_PIN_LFB		PIND				// Pin declaration of ZLDO LBF pin

#define ZLDO_DDR_SC			DDRD				// Data direction reg. of ZLDO SC pin
#define ZLDO_PORT_SC		PORTD				// Port declaration of ZLDO SC pin
#define ZLDO_PNR_SC			PD6					// Pin number of ZLDO SC pin
#define ZLDO_IPN_SC			PIND6				// Input Pin number of ZLDO SC pin
#define ZLDO_PIN_SC			PIND				// Pin declaration of ZLDO SC pin
// ***************************


// **** RFM12 DEFINITIONS ****
#define RF_PORT	PORTB							// Port of the AVR on which the module is connected to
#define RF_DDR	DDRB							// Data direction register of the used port
#define RF_PIN	PINB							// Pin assignment

#define SDI		2								// The Pin-Number of the AVR that is connected with the SDI-Pin of the RFM12
#define SCK		3								// The Pin-Number of the AVR that is connected with the SCK-Pin of the RFM12
#define CS		4								// The Pin-Number of the AVR that is connected with the nSEL-Pin of the RFM12
#define SDO		1								// The Pin-Number of the AVR that is connected with the SDO-Pin of the RFM12
#define NIRQ	2								// Optional Pin-Assignments; The Pin-Number of the AVR that is connected with the nIRG-Pin of the RFM12
// ***************************


// **** CLEAR AND SET BITS ****												
#ifndef cbi										// Macros to clear bits (cbi) and set bits (sbi)
#define cbi(sfr, bit)     (_SFR_BYTE(sfr) &= ~_BV(bit)) 
#endif
#ifndef sbi
#define sbi(sfr, bit)     (_SFR_BYTE(sfr) |= _BV(bit))  
#endif
// ***************************


// * MISCELLANEOUS DEFINITIONS *
#define OFF 0									// Synonym for all purposes								
#define ON  1

#define LED_OFF 0								// Some LED synonyms				
#define LED_ON  1

#define ACK		0								// Acknowledge definitions
#define NACK	1								// Acknowledge definitions

#define CRC16	0xA631UL						// Checksum 16 Bit constant (do not change!!)
#define CRC8	0xAA							// Checksum  8 Bit constant (do not change!!)

#define MBF		70								// Maximal amout of bytes to transmit / receive
// ***************************


// **** STATUS REGISTER ***** 
#define FIFO_IN_DATAAVAIL		0				// For Status register: FIFO input buffer data available
#define FIFO_IN_EMPTY			1				// For Status register: FIFO input buffer empty
#define FIFO_IN_BUFFOVERFLOW	2				// For Status register: FIFO input buffer overflow
#define FIFO_OUT_READY			3				// For Status register: FIFO output buffer ready to receive the next byte
#define FIFO_OUT_EMPTY			4				// For Status register: FIFO output buffer empty
#define FIFO_OUT_BUFFOVERFLOW	5				// For Status register: FIFO output buffer overflow
#define ERROR_STATUS			8				// For Status register: Error status
#define ERROR_BEGIN_MESSAGE		9				// For Status register: Error message
#define LOW_BATTERY_FLAG		11				// For Status register: Low battery flag
// ***************************


// *** COMPILER DEFINITIONS ***
#ifndef EEMEM
#define EEMEM  __attribute__ ((section (".eeprom"))) // alle Textstellen EEMEM im Quellcode durch __attribute__ ... ersetzen
#endif
#define nop() asm volatile("nop")				// No operation
// ***************************


/** END OF MODULE ******************************************************/
